// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers','nfcFilters','ngCordova'])

.run(function($rootScope, $ionicPlatform, $filter,$location,$state,$ionicPopup,$cordovaSQLite) {
	var tag = {};
		var writeFlag=false;
		var msg="";

  $ionicPlatform.ready(function(localStorage) {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }

    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
	
	setInterval(function() {
		
  // method to be executed;
 
		   //console.log("Enter Background Event..................");
	
	/****** NFC *********/
		/*nfc.addNdefFormatableListener(
        function (ndefTable) {
          //alert("ndefTable");
          return ndefTable.tag.id;
        }
      );
      nfc.addNdefListener(
        function (nfcEvent) {
			//console.log("Enter NFC Background Event.................."+nfcEvent);
          //alert("nfcEvent");
          //alert(nfcEvent.tag.id);
		  var record=nfcEvent.tag.ndefMessage;
		  var recordType = nfc.bytesToString(record[0].type);
		  var payload="";
		  console.log("recordType is -->"+recordType);
		  if (recordType === "T") {
                payload = ndef.textHelper.decodePayload(record[0].payload);
            } else if (recordType === "U") {
                payload = ndef.uriHelper.decodePayload(record[0].payload);
			}
			//alert(payload);
          return nfcEvent.tag.id;
        },
		function(success){
			$rootScope.nfcStatus=true;
			$rootScope.nfcStatusClass = 'ng-show';
		},
		function(error){
			$rootScope.nfcStatus=false;
			$rootScope.nfcStatusClass = 'ng-hide';
		}
      );
      nfc.addMimeTypeListener(
        function (mimeType) {
          //alert("mimeType");
          return mimeType.tag.id;
        }
      );
      nfc.addTagDiscoveredListener(
        function (tagDiscover) {
          //alert("tagDiscover");
          return tagDiscover.tag.id;
        }
	);*/
	/****** NFC *********/
	
	}, 1000);
	
		$ionicPlatform.registerBackButtonAction(function(e) {
		//alert("alert");
		e.preventDefault();	
		//e.stopPropagation();			
		//alert("alert");
		if($location.$$path == "/home"){
			console.log("Goto Logout"+$location.$$path);
			
						  e.preventDefault();	
						  e.stopPropagation();
						  if(window.localStorage.rememberMe == 1){
							  console.log(window.localStorage.rememberMe);
							  navigator.app.exitApp();
						  }
						  else if(window.localStorage.rememberMe == 0){
							  console.log(window.localStorage.rememberMe);
							  showConfirm();
						  }
						  
					  }
					  else if($location.$$path == "/login"){
						window.localStorage.clear();
						navigator.app.exitApp();
					  }
					  else{
						  console.log("Goto List");
						  $state.go('home');
					  }
		//showConfirm();
		function showConfirm() {
			console.log("showConfirm");
					var confirmPopup = $ionicPopup.confirm({
					 title: 'Logout',
					 template: 'Are you sure you want to logout?',
					 okType: 'button-d2h',
					 okText: 'YES',
					 //buttons: [{ text: 'Tag' }],
					 cancelType: 'button-d2h-cancel',
					 cancelText: 'NO'
					 //buttons: [{ text: 'Cancel' }]
				   });

				   confirmPopup.then(function(res) {
					 if(res) {
						 //console.log("Locale before:"+localStorage.username);
						window.localStorage.clear();
						//console.log("Locale After:"+localStorage.username);
						console.log(window.localStorage.rememberMe);
						navigator.app.exitApp();
					 } else {
						//$state.go('list');
						
					   console.log('You are not sure');
					 }
				   });
					   
					   }
					 e.stopPropagation();
				return false;				
		  },101);

	
  });
})

.config(function($stateProvider, $urlRouterProvider) {
	
	// configure Idle settings
    //IdleProvider.idle(10); // in seconds
    //IdleProvider.timeout(5); // in seconds
    //KeepaliveProvider.interval(2); // in seconds

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

     .state('login', {
    url: '/login',
	templateUrl: 'templates/login.html',
	controller: 'LoginCtrl'
    })
  
  // setup an abstract state for the tabs directive
  


  // Each tab has its own nav history stack:
   
  .state('design', {
      url: '/design',
      //views: {
        //'tagasset': {
          templateUrl: 'templates/design.html',
          controller: 'DesignCtrl'
        //}
      //}
    })	  
	
  .state('home', {
      url: '/home',
      //views: {
        //'list': {
          templateUrl: 'templates/home.html',
          controller: 'HomeCtrl'
        //}
      //}
    })

  .state('prospectdetails', {
      url: '/prospectdetails',
      //views: {
        //'list': {
          templateUrl: 'templates/prospectdetails.html',
          controller: 'ProspectCtrl'
        //}
      //}
    })	
	
  .state('support', {
      url: '/support',
      //views: {
        //'list': {
          templateUrl: 'templates/support.html',
          controller: 'SupportCtrl'
        //}
      //}
    })	

	;

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');

});

